package lib::Login;
$VERSION = 1.00;
use CGI::Carp qw(fatalsToBrowser);
use strict;

{
# Encapsulated class data

	# Default constructor values
	my %_attr_data = #  DEFAULT
	   ( _action   => [ ""                         ],
	     _redirect => [ "memb_main"                ],
	     _title    => [ "Poll Master Member Login" ],
	   );

# Class methods, to operate on encapsulated class data

	# Classwide default value for all specified object attributes
	sub _default_for
	{
		my ($self, $attr) = @_;
		$_attr_data{$attr}[0];
	}

	# List of names of all specified object attributes
	sub _standard_keys
	{
		keys %_attr_data;
	}
	
	
	# Display login screen
	sub _display
	{
		my $self = shift;
		print "Content-type: text/html\n\n";

		print qq(<html>
		         <head>
		         <title>$self->{_title}</title>
		         <link href="$main::NONCGI_URL/styles/pm.css" rel="stylesheet" type="text/css">
		         </head>
		         <body onload="document.adform1.user_name.focus()">
		         $main::GUI_HEADING
		         <form style="margin: 0px;" name="adform1" method="post" action="$self->{_action}">
		         <input name="redirect" type="hidden" id="redirect" value="$self->{_redirect}">
		         <table width="400" border="0" align="center" cellpadding="0" cellspacing="0">
		         <tr> 
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="172" height="1" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="115" height="1" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="110" height="1" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="3" height="1" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="1" height="1" border="0" alt=""></td>
		         </tr>
		         <tr> 
		         <td colspan="4"><img name="PM_Logon_Screen_Fireworks_r1_c1" src="$main::NONCGI_URL/pm_logon_screen/PM_Logon_Screen_Fireworks_r1_c1.jpg" width="400" height="88" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="1" height="88" border="0" alt=""></td>
		         </tr>
		         <tr> 
		         <td rowspan="3"><img name="PM_Logon_Screen_Fireworks_r2_c1" src="$main::NONCGI_URL/pm_logon_screen/PM_Logon_Screen_Fireworks_r2_c1.jpg" width="172" height="162" border="0" alt=""></td>
		         <td colspan="2" bgcolor="#FFFFFF"><table width="95%" border="0" cellspacing="0" cellpadding="1">
		         <tr> 
		         <td class="loginlabel"><font color="#336699" size="$main::PRIMARY_FONT_SIZE" face="$main::FONT_FACE">User 
		         name:</font></td>
		         <td><div align="right"> 
		         <input name="user_name" type="text" class="logininputbox" size="15" maxlength="150">
		         </div></td>
		         </tr>
		         <tr> 
		         <td class="loginlabel"><font color="#336699" size="$main::PRIMARY_FONT_SIZE" face="$main::FONT_FACE">Password:</font></td>
		         <td><div align="right"> 
		         <input name="password" type="password" class="logininputbox" id="password" size="15" maxlength="20">
		         </div></td>
		         </tr>
		         <tr> 
		         <td>&nbsp;</td>
		         <td><div align="right"> 
		         <input name="login" type="submit" class="loginbutton" id="login" value="Log In">
		         </div></td>
		         </tr>
		         </table></td>
		         <td rowspan="3"><img name="PM_Logon_Screen_Fireworks_r2_c4" src="$main::NONCGI_URL/pm_logon_screen/PM_Logon_Screen_Fireworks_r2_c4.jpg" width="3" height="162" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="1" height="93" border="0" alt=""></td>
		         </tr>
		         <tr> 
		         <td><img name="PM_Logon_Screen_Fireworks_r3_c2" src="$main::NONCGI_URL/pm_logon_screen/PM_Logon_Screen_Fireworks_r3_c2.jpg" width="115" height="14" border="0" alt=""></td>
		         <td rowspan="2"><img name="PM_Logon_Screen_Fireworks_r3_c3" src="$main::NONCGI_URL/pm_logon_screen/PM_Logon_Screen_Fireworks_r3_c3.jpg" width="110" height="69" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="1" height="14" border="0" alt=""></td>
		         </tr>
		         <tr> 
		         <td><img name="PM_Logon_Screen_Fireworks_r4_c2" src="$main::NONCGI_URL/pm_logon_screen/PM_Logon_Screen_Fireworks_r4_c2.jpg" width="115" height="55" border="0" alt=""></td>
		         <td><img src="$main::NONCGI_URL/pm_logon_screen/spacer.gif" width="1" height="55" border="0" alt=""></td>
		         </tr>
		         </table>
		         </form>
		         $main::GUI_FOOTER
		         </body>
		         </html>
		        );
		exit;
	}
}

# Constructor
sub new
{
	my ($class, %arg) = @_;
	my $self = bless {}, $class;
	foreach my $attrname ( $self->_standard_keys() )
	{
		my ($argname) = ($attrname =~ /^_(.*)/);
		if (exists $arg{$argname})
		   { $self->{$attrname} = $arg{$argname} }
		else
		   { $self->{$attrname} = $self->_default_for($attrname) }
	}
	$self->{_action} = "$main::SCRIPT_URL/members.cgi" if !$self->{_action};	# Action needs to be set separately due to use of global variable
	$self->_display();
	return $self;
}

1;